#include <direct.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include "ls11_lib.h"

using namespace std;



int ls11_DecodePack(char *szInputFileName, char *szOutputPattern, vector<vector<byte>> *pvecDstDataArray) {

	// nꂽxN^[͔Ô߃NA[
	if ( pvecDstDataArray ) {
		pvecDstDataArray->clear();
	}

	int iTtargetFileSize=0;
	int iKeepableMemSize=0;
	int iOutputFileSize=0;
	char *inData=NULL;
	char *outData=NULL;
	/*
	printf("̓t@C:");
	scanf("%s",input);
	printf("o̓t@C:");
	scanf("%s",output);
	*/
	/* t@CTCY擾 */
	iTtargetFileSize = ls11_getFileSize(szInputFileName);
	if(iTtargetFileSize < 0){
		fflush(stdin);
		return -1;
	}
	inData = (char *)calloc(iTtargetFileSize , sizeof(char));
	if(inData == NULL ){
		//printf("̈擾G[\n");
		fflush(stdin); 
		return -1;
	}
	iTtargetFileSize = ls11_getFileData(szInputFileName, inData, iTtargetFileSize);
	if(iTtargetFileSize < 0){
		free(inData);
		fflush(stdin);
		return -1;
	}
	//printf("f[^:%d\n",iTtargetFileSize);

	/* WJ */
	int result = ls11_memLocationDataArray(inData, iTtargetFileSize);
	if ( result == -1 ) {
		free(inData);
		fflush(stdin);
		return -1;
	}

	// ͋ʂȂ̂ŃRs[
	memcpy( &ls11_onedata.dictionary, inData, sizeof(ls11_onedata.dictionary) );
	ls11_onedata.zero = 0;

	// ɂ
	for (int i=0; i<(int)ls11_location_data_list.size(); i++ ) {
		// TCY֘ARs[
		memcpy(&ls11_onedata.locationdata, &ls11_location_data_list[i], sizeof(ls11_location_data_list) );
		memcpy(&ls11_onedata.data, inData+ls11_location_data_list[i].iStartAddress, ls11_location_data_list[i].iDataLenSize);

		//printf("mۃTCY:%d\n",ls11_location_data_list[i].iExpandedSize);

		if(ls11_location_data_list[i].iExpandedSize <= 0){
			//printf("WJTCY擾ł܂\n");
			//fflush(stdin);
			return -1;
		}

		outData = (char *)calloc(ls11_location_data_list[i].iExpandedSize+50000 , sizeof(char)); // 50000Đl͕ʂ̂ƂŎQƂĂB

		if(outData == NULL ){
			free(inData);
			//printf("̈擾G[\n");
			fflush(stdin); 
			return -1;
		}
		iKeepableMemSize = ls11_Decode((char *)&ls11_onedata, sizeof(ls11_onedata), outData, ls11_location_data_list[i].iExpandedSize );	
		//printf("o̓TCY:%d\n",iKeepableMemSize);
		// mۂłȂ
		if(iKeepableMemSize < 0){
			//printf("GR[hs:%d\n",iKeepableMemSize);
			fflush(stdin); 
			free(outData);
			return -1;
		}

		// t@Co̓p^[킽ĂĂꍇ́At@Co
		if ( szOutputPattern ) {
			// fBNg쐬
			_mkdir(szOutputPattern);
			// t@C쐬B*****.001@Ȃ
			char szTmpOutputPattern[256] = "";
			sprintf_s(szTmpOutputPattern, "%s/%s.%03d", szOutputPattern,szOutputPattern, i);
			printf(szTmpOutputPattern);

			/* ϊꂽf[^o */
			iOutputFileSize = ls11_outFileData(szTmpOutputPattern, outData, ls11_location_data_list[i].iExpandedSize);
			// o͂Ɏs
			if ( iOutputFileSize == -1 ) {
				free(outData);// mallocɑΉ
				return -1;
			}
		}

		// xNgXg킽ĂĂꍇ́AxNgɏo
		if ( pvecDstDataArray ) {
			// vectorɈꊇRsy
			vector<byte> buf(&outData[0], &outData[ls11_location_data_list[i].iExpandedSize]);
			// nꂽxNgzAppend
			pvecDstDataArray->push_back(buf);
		}
		free(outData);// mallocɑΉ
	}

	free(inData);

	//	}

	//printf("ϊI\n");
	//fflush(stdin);
	return 0;
}

/*
g

vector<vector<byte>> v; ^CvnƂŁAeXv̒ɁAeoCit@C(****.000, ****.001̒g)̂܂ܓ

int main(int argc , char *argv[]){
	vector<vector<byte>> vDataArray;
	ls11_DecodePack("hexgrp.nb6", "hexgrp" , &vDataArray);

	return 0;
}
*/